Summary: The GNU libc libraries.
Name: glibc
Version: 2.3.5
%define glibcdate 20040701
Release: 10tr
License: LGPL
Group: Trustix Official
Source0: %{name}-%{version}.tar.bz2
Source1: %{name}-linuxthreads-%{version}.tar.bz2
Source2: locales-gen
Source3: nsswitch.conf
Source5: nscd.init
#Patch0: %{name}-redhat.patch
Patch1: glibc-2.3.4-tls.patch
Patch2: pthread_conf.patch
Patch3: glibc-2.3-gcc4.patch
Patch4: glibc-2.3.5-path_vi.patch
Patch5: glibc-tzdata-update.patch
Buildroot: %{_tmppath}/%{name}-root
Requires: tzdata
BuildRequires: binutils >= 2.13
%define dualarch ppc64 x86_64
%define enablekernel 2.4.20
%ifarch i586
%define enablekernelltfs 2.4.20
%endif
%define nptlarches i586 x86_64 ppc64
%ifarch %{nptlarches}
%define enablekernelnptl 2.6.2
%endif

%description
The glibc package contains standard libraries which are used by multiple
programs on the system. In order to save disk space and memory, as well as to
make upgrading easier, common system code is kept in one place and shared
between programs. This particular package contains the most important sets of
shared libraries: the standard C library and the standard math library. Without
these two libraries, a Linux system will not function.  The glibc package also
contains national language (locale) support and timezone databases.

%ifarch %{dualarch}
%package 32bit
Summary: The 32 bit GNU libc libraries.
Group: Trustix Official
BuildRequires: binutils >= 2.13
Requires: glibc
Obsoletes: glibc32

%description 32bit
The glibc package contains standard libraries which are used by multiple
programs on the system. In order to save disk space and memory, as well as to
make upgrading easier, common system code is kept in one place and shared
between programs. This particular package contains the most important sets of
shared libraries: the standard C library and the standard math library. Without
these two libraries, a Linux system will not function.  The glibc package also
contains national language (locale) support and timezone databases.

This is the 32-bit version
%endif

%package devel
Summary: Header and object files for development using standard C libraries.
Group: Trustix Official
Requires: linux-headers
BuildRequires: linux-headers
Provides: %{name}-nptl-devel
Obsoletes: %{name}-nptl-devel

%description devel
The glibc-devel package contains the header and object files necessary for
developing programs which use the standard C libraries (which are used by
nearly all programs).  If you are developing programs which will use the
standard C libraries, your system needs to have these standard header and
object files available in order to create the executables.

%ifarch %{dualarch}
%package 32bit-devel
Summary: Header and object files for development using standard 32 bit C libraries.
Group: Trustix Official
Requires: linux-headers
BuildRequires: linux-headers
Requires: glibc-devel
Obsoletes: glibc32-devel

%description 32bit-devel
The glibc-devel package contains the header and object files necessary for
developing programs which use the standard C libraries (which are used by
nearly all programs).  If you are developing programs which will use the
standard C libraries, your system needs to have these standard header and
object files available in order to create the executables.

Install glibc-devel if you are going to develop programs which will use the
standard C libraries.

This is the 32-bit version
%endif

%package profile
Summary: The GNU libc libraries, including support for gprof profiling.
Group: Trustix Official

%description profile
The glibc-profile package includes the GNU libc libraries and support for
profiling using the gprof program.  Profiling is analyzing a program's
functions to see how much CPU time they use and determining which functions are
calling other functions during execution.  To use gprof to profile a program,
your program needs to use the GNU libc libraries included in glibc-profile
(instead of the standard GNU libc libraries included in the glibc package).

If you are going to use the gprof program to profile a program, you'll need to
install the glibc-profile program.

%ifarch %{dualarch}
%package 32bit-profile
Summary: The 32 bit GNU libc libraries, including support for gprof profiling.
Group: Trustix Official
Requires: glibc-profile
Obsoletes: glibc32-profile

%description 32bit-profile
The glibc-profile package includes the GNU libc libraries and support for
profiling using the gprof program.  Profiling is analyzing a program's
functions to see how much CPU time they use and determining which functions are
calling other functions during execution.  To use gprof to profile a program,
your program needs to use the GNU libc libraries included in glibc-profile
(instead of the standard GNU libc libraries included in the glibc package).

If you are going to use the gprof program to profile a program, you'll need to
install the glibc-profile program.

This is the 32-bit version
%endif

%package nscd
Summary: A Name Service Caching Daemon (nscd).
Group: Trustix Official
Conflicts: kernel < 2.2.0
Prereq: chkconfig, tsl-utils
Obsoletes: nscd


%description nscd
Nscd caches name service lookups and can dramatically improve performance with
NIS+, and may help with DNS as well. Note that you can't use nscd with 2.0
kernels because of bugs in the kernel-side thread support. Unfortunately, nscd
happens to hit these bugs particularly hard.

Install nscd if you need a name service lookup caching daemon, and you're not
using a version 2.0 kernel.

%package locales
Summary: Locale enviroment settings
Group: Trustix Official
Conflicts: kernel < 2.2.0
Prereq: /sbin/chkconfig
Requires: glibc

%description locales
Glibc-locales includes the data files for the glibc national language support
(locale). The files necessary for the 'en_US ISO-8859-1' locale is included in
the main package.

Install locales if you need extra native language support.

%prep
%setup -q -a 1 -n %{name}-%{version}
# -a1
#%patch0 -p1
#%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1

# A lot of programs still misuse memcpy when they have to use
# memmove. The memcpy implementation below is not tolerant at
# all.
rm -f sysdeps/alpha/alphaev6/memcpy.S

find . -type f -size 0 -o -name "*.orig" -exec rm -f {} \;
cat > find_provides.sh <<EOF
#!/bin/sh
/usr/lib/rpm/find-provides | grep -v GLIBC_PRIVATE
exit 0
EOF
chmod +x find_provides.sh
touch `find . -name configure`

%build
perl -pi -e "s/^# chkconfig:.*$/# chkconfig: - 32 68/" %{SOURCE5}
%define real_arch %{_target_cpu}
%define all_arch %{real_arch}
%define minor_arch false

%ifarch %{ix86}
BuildFlags="-march=%{_target_cpu}"
%endif
%ifarch x86_64
%define minor_arch i386
%define all_arch %{minor_arch} %{real_arch}
%endif
%ifarch ppc64
BuildFlags="-mno-minimal-toc"
%define minor_arch ppc
%define all_arch %{minor_arch} %{real_arch}
%endif

for arch in %{all_arch}; do
export GCC_ORIG="gcc"
if [ "$arch" == "%{minor_arch}" ]; then
	export GCC_ORIG="gcc -m32"
fi
rm -rf build-$arch-linux
mkdir build-$arch-linux
pushd build-$arch-linux
#
# Create working include dir
#
mkdir rpm-includes
pushd rpm-includes/
ln -s /usr/include/asm-$arch asm
GCC="$GCC_ORIG -nostdinc -I`pwd` -I/usr/include"
popd

# If gcc supports __thread, test it even in --with-tls --without-__thread
# builds.
if echo '__thread int a;' | $GCC -xc - -S -o /dev/null 2>/dev/null; then
  perl -pi -e 's/0 \|\|/1 ||/' ../elf/tst-tls10.h ../linuxthreads/tst-tls1.h
fi

BuildFlags="$BuildFlags -DNDEBUG=1"
if gcc -v 2>&1 | grep -q 'gcc version 3'; then
  BuildFlags="$BuildFlags -finline-limit=2000"
fi
EnableKernel="--enable-kernel=%{enablekernel}"
echo "$BuildFlags" > ../BuildFlags
echo "$GCC" > ../Gcc
AddOns=`cd .. && echo */configure | sed -e 's!/configure!!g;s!\(linuxthreads\|nptl\|rtkaio\)\( \|$\)!!g;s! \+$!!;s! !,!g;s!^!,!;/^,\*$/d;/^,/d'`
echo "$AddOns" > ../AddOns

Pthreads=linuxthreads
WithTls="--with-tls --without-__thread"
CC="$GCC" CFLAGS="$BuildFlags -g -O3" ../configure --prefix=%{_prefix} \
        --enable-add-ons=$Pthreads$AddOns --without-cvs $EnableKernel \
        --with-headers=%{_prefix}/include --enable-bind-now \
        $WithTls --build $arch-trustix-linux --host $arch-trustix-linux 
	

if [ -x /usr/bin/getconf ] ; then
  numprocs=$(/usr/bin/getconf _NPROCESSORS_ONLN)
  if [ $numprocs -eq 0 ]; then
    numprocs=1
  fi
else
  numprocs=1
fi
pwd
make -j$numprocs -r CFLAGS="$BuildFlags -g -O3" PARALLELMFLAGS=-s
cd ..
done

# hack
unset LD_ASSUME_KERNEL || :

%ifarch i586 
rm -rf build-$arch-linuxltfs
mkdir build-$arch-linuxltfs ; cd build-$arch-linuxltfs
EnableKernel="--enable-kernel=%{enablekernelltfs} --disable-profile"
Pthreads=linuxthreads
WithTls="--with-tls --without-__thread"
CC="$GCC" CFLAGS="$BuildFlags -g -O3" ../configure --prefix=%{_prefix} \
	--enable-add-ons=$Pthreads$AddOns --without-cvs $EnableKernel \
	--with-headers=%{_prefix}/include --enable-bind-now \
	$WithTls --build $arch-trustix-linux --host $arch-trustix-linux
make -j$numprocs -r CFLAGS="$BuildFlags -g -O3" PARALLELMFLAGS=-s

cd ..
%endif

%ifarch %{nptlarches}
rm -rf build-$arch-linuxnptl
mkdir build-$arch-linuxnptl ; cd build-$arch-linuxnptl
EnableKernel="--enable-kernel=%{enablekernelnptl} --disable-profile"
Pthreads=nptl
WithTls="--with-tls --with-__thread"
CC="$GCC" CFLAGS="$BuildFlags -g -O3" ../configure --prefix=%{_prefix} \
	--enable-add-ons=$Pthreads$AddOns --without-cvs $EnableKernel \
	--with-headers=%{_prefix}/include --enable-bind-now \
	$WithTls --build $arch-trustix-linux --host $arch-trustix-linux
make -j$numprocs -r CFLAGS="$BuildFlags -g -O3" PARALLELMFLAGS=-s

cd ..
%endif

%install
[ -n "$RPM_BUILD_ROOT" -a "$RPM_BUILD_ROOT" != / ] && rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT
# hack
unset LD_ASSUME_KERNEL || :
BuildFlags=`cat BuildFlags`
GCC=`cat Gcc`
AddOns=`cat AddOns`

if [ -x /usr/bin/getconf ] ; then
  numprocs=$(/usr/bin/getconf _NPROCESSORS_ONLN)
  if [ $numprocs -eq 0 ]; then
    numprocs=1
  fi
else
  numprocs=1
fi

make -j1 install_root=$RPM_BUILD_ROOT install -C build-%{_target_cpu}-linux PARALLELMFLAGS=-s

SubDir=

%ifarch i586
cd build-%{_target_cpu}-linuxltfs
Pthreads=linuxthreads
SubDir=i586
mkdir -p $RPM_BUILD_ROOT/lib/$SubDir/
cp -a libc.so $RPM_BUILD_ROOT/lib/$SubDir/`basename $RPM_BUILD_ROOT/lib/libc-*.so`
ln -sf `basename $RPM_BUILD_ROOT/lib/libc-*.so` $RPM_BUILD_ROOT/lib/$SubDir/`basename $RPM_BUILD_ROOT/lib/libc.so.*`
cp -a math/libm.so $RPM_BUILD_ROOT/lib/$SubDir/`basename $RPM_BUILD_ROOT/lib/libm-*.so`
ln -sf `basename $RPM_BUILD_ROOT/lib/libm-*.so` $RPM_BUILD_ROOT/lib/$SubDir/`basename $RPM_BUILD_ROOT/lib/libm.so.*`
cp -a $Pthreads/libpthread.so $RPM_BUILD_ROOT/lib/$SubDir/`basename $RPM_BUILD_ROOT/lib/libpthread-*.so`
pushd $RPM_BUILD_ROOT/lib/$SubDir
ln -sf libpthread-*.so `basename $RPM_BUILD_ROOT/lib/libpthread.so.*`
popd
cp -a rt/librt.so $RPM_BUILD_ROOT/lib/$SubDir/`basename $RPM_BUILD_ROOT/lib/librt-*.so`
ln -sf `basename $RPM_BUILD_ROOT/lib/librt-*.so` $RPM_BUILD_ROOT/lib/$SubDir/`basename $RPM_BUILD_ROOT/lib/librt.so.*`
cd ..
%endif

%ifarch %{nptlarches}
cd build-%{_target_cpu}-linuxnptl
Pthreads=nptl
SubDir=tls
mkdir -p $RPM_BUILD_ROOT/%{_lib}/$SubDir/
cp -a libc.so $RPM_BUILD_ROOT/%{_lib}/$SubDir/`basename $RPM_BUILD_ROOT/%{_lib}/libc-*.so`
ln -sf `basename $RPM_BUILD_ROOT/%{_lib}/libc-*.so` $RPM_BUILD_ROOT/%{_lib}/$SubDir/`basename $RPM_BUILD_ROOT/%{_lib}/libc.so.*`
cp -a math/libm.so $RPM_BUILD_ROOT/%{_lib}/$SubDir/`basename $RPM_BUILD_ROOT/%{_lib}/libm-*.so`
ln -sf `basename $RPM_BUILD_ROOT/%{_lib}/libm-*.so` $RPM_BUILD_ROOT/%{_lib}/$SubDir/`basename $RPM_BUILD_ROOT/%{_lib}/libm.so.*`
cp -a $Pthreads/libpthread.so $RPM_BUILD_ROOT/%{_lib}/$SubDir/libpthread-%{version}.so
pushd $RPM_BUILD_ROOT/%{_lib}/$SubDir
ln -sf libpthread-*.so `basename $RPM_BUILD_ROOT/%{_lib}/libpthread.so.*`
popd
cp -a rt/librt.so $RPM_BUILD_ROOT/%{_lib}/$SubDir/`basename $RPM_BUILD_ROOT/%{_lib}/librt-*.so`
ln -sf `basename $RPM_BUILD_ROOT/%{_lib}/librt-*.so` $RPM_BUILD_ROOT/%{_lib}/$SubDir/`basename $RPM_BUILD_ROOT/%{_lib}/librt.so.*`
cp -a ${Pthreads}_db/libthread_db.so $RPM_BUILD_ROOT/%{_lib}/$SubDir/`basename $RPM_BUILD_ROOT/%{_lib}/libthread_db-*.so`
ln -sf `basename $RPM_BUILD_ROOT/%{_lib}/libthread_db-*.so` $RPM_BUILD_ROOT/%{_lib}/$SubDir/`basename $RPM_BUILD_ROOT/%{_lib}/libthread_db.so.*`

mkdir -p $RPM_BUILD_ROOT%{_prefix}/%{_lib}/nptl
cp -a libc.a nptl/libpthread.a nptl/libpthread_nonshared.a rt/librt.a \
  $RPM_BUILD_ROOT%{_prefix}/%{_lib}/nptl/
sed "s| /%{_lib}/| /%{_lib}/$SubDir/|" $RPM_BUILD_ROOT%{_prefix}/%{_lib}/libc.so \
  > $RPM_BUILD_ROOT%{_prefix}/%{_lib}/nptl/libc.so
sed "s|^GROUP (.*)|GROUP ( /%{_lib}/$SubDir/"`basename $RPM_BUILD_ROOT/%{_lib}/libpthread.so.*`' %{_prefix}/%{_lib}/nptl/libpthread_nonshared.a )|' \
  $RPM_BUILD_ROOT%{_prefix}/%{_lib}/libc.so \
  > $RPM_BUILD_ROOT%{_prefix}/%{_lib}/nptl/libpthread.so
ln -sf %{_lib}/$SubDir/`basename $RPM_BUILD_ROOT/%{_lib}/librt-*.so` \
  $RPM_BUILD_ROOT%{_prefix}/%{_lib}/nptl/librt.so

strip -g $RPM_BUILD_ROOT%{_prefix}/%{_lib}/nptl/*.a
mkdir -p $RPM_BUILD_ROOT/nptl $RPM_BUILD_ROOT%{_prefix}/include/nptl
make -j1 install_root=$RPM_BUILD_ROOT/nptl install-headers PARALLELMFLAGS=-s
pushd $RPM_BUILD_ROOT/nptl%{_prefix}/include
  for i in `find . -type f`; do
    if ! [ -f $RPM_BUILD_ROOT%{_prefix}/include/$i ] \
       || ! cmp -s $i $RPM_BUILD_ROOT%{_prefix}/include/$i; then
      mkdir -p $RPM_BUILD_ROOT%{_prefix}/include/nptl/`dirname $i`
      cp -a $i $RPM_BUILD_ROOT%{_prefix}/include/nptl/$i
    fi
  done
popd
rm -rf $RPM_BUILD_ROOT/nptl

cd ..
%endif

# the man pages for the linuxthreads require special attention
make -C linuxthreads/man
mkdir -p $RPM_BUILD_ROOT%{_mandir}/man3
install -m 0644 linuxthreads/man/*.3thr $RPM_BUILD_ROOT%{_mandir}/man3
gzip -9nvf $RPM_BUILD_ROOT%{_mandir}/man3/*

#
# Take care of last piece of libbsd-compat:
#
ln -sf libbsd-compat.a $RPM_BUILD_ROOT/%{_libdir}/libbsd.a || :
ln -sf libbsd-compat.a $RPM_BUILD_ROOT/%{_prefix}/lib/libbsd.a || :



# Get to know which locales are supported:
grep -v '#' < localedata/SUPPORTED | \
	sed "s|/| |" | \
	sed "s|\\\| |" | \
	grep -v 'SUPPORTED-LOCALES=' | \
	grep -v 'ja_JP.EUC-JP' | \
	grep -v 'ko_KR.EUC-KR' | \
	grep -v 'ko_KR.UTF-8' | \
	grep -v 'ru_RU.KOI8-R' | \
	grep -v 'zh_CN.GB18030' | \
	grep -v 'zh_CN.GBK' | \
	grep -v 'zh_TW.EUC-TW' \
	> supported_locales_temp.txt

cat supported_locales_temp.txt | sed s/\\.UTF-8//g | \
        sed s/\\.GBK//g | \
        sed s/\\.TCVN//g | \
        sed s/\\.ISO-8859-15//g \
        > supported_locales.txt

# create locales.conf:
echo '# This file define additional NLS-locales to be generated.' \
	> locales.conf
echo '# Uncomment any locale you want to be generated.' \
	>> locales.conf
echo '# Then run /usr/sbin/locales-gen to generate the choosen locales'\
	>> locales.conf

check='-1'
lang='null'
char='null'


for i in $(cat supported_locales.txt); do
	if (test "$check" = -1)
	then
		lang=$i
		check=1
	else
		char=$i
		check=-1
		echo "# $lang $char" >> locales.conf
	fi
done
echo -n '# This is the end.' >> locales.conf	 


mkdir -p $RPM_BUILD_ROOT%{_datadir}/locale
mkdir -p $RPM_BUILD_ROOT%{_prefix}/lib/locale

install -m 644 locales.conf \
	$RPM_BUILD_ROOT%{_sysconfdir}/locales.conf

install -m 644 supported_locales.txt \
	$RPM_BUILD_ROOT%{_datadir}/locale/supported_locales.txt

# locales-gen
install -m 750 %SOURCE2 $RPM_BUILD_ROOT%{_sbindir}/locales-gen

# the man pages for the linuxthreads require special attention
make -C linuxthreads/man
mkdir -p $RPM_BUILD_ROOT%{_mandir}/man3
install -m 0644 linuxthreads/man/*.3thr $RPM_BUILD_ROOT%{_mandir}/man3
gzip -9nvf $RPM_BUILD_ROOT%{_mandir}/man3/*.3thr

# This is for ncsd
install -m 644 nscd/nscd.conf $RPM_BUILD_ROOT/%{_sysconfdir}/
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/init.d
mkdir -p $RPM_BUILD_ROOT/var/{db,run}/nscd
touch $RPM_BUILD_ROOT/var/run/nscd/{socket,nscd.pid}
install -m 755 %{SOURCE5} $RPM_BUILD_ROOT%{_sysconfdir}/init.d/nscd

# This is the nss config file
install -m 644 $RPM_SOURCE_DIR/nsswitch.conf $RPM_BUILD_ROOT%{_sysconfdir}/

# The database support
mkdir -p $RPM_BUILD_ROOT%{_localstatedir}/db

# Strip binaries
strip $RPM_BUILD_ROOT/sbin/* || :
strip $RPM_BUILD_ROOT/%{_bindir}/* || :
strip $RPM_BUILD_ROOT/%{_sbindir}/* || :

# Strip the .so's
strip $RPM_BUILD_ROOT/lib/*.so || :
strip $RPM_BUILD_ROOT/%{_lib}/*.so || :


# Create ghosts (-locales hack):
for i in $(cat supported_locales.txt | cut -d " " -f 1); do
	mkdir -p ${RPM_BUILD_ROOT}%{_prefix}/lib/locale/$i/LC_MESSAGES
	touch ${RPM_BUILD_ROOT}%{_prefix}/lib/locale/$i/LC_ADDRESS
	touch ${RPM_BUILD_ROOT}%{_prefix}/lib/locale/$i/LC_COLLATE
	touch ${RPM_BUILD_ROOT}%{_prefix}/lib/locale/$i/LC_CTYPE
	touch ${RPM_BUILD_ROOT}%{_prefix}/lib/locale/$i/LC_IDENTIFICATION
	touch ${RPM_BUILD_ROOT}%{_prefix}/lib/locale/$i/LC_MEASUREMENT
	touch ${RPM_BUILD_ROOT}%{_prefix}/lib/locale/$i/LC_MONETARY
	touch ${RPM_BUILD_ROOT}%{_prefix}/lib/locale/$i/LC_NAME
	touch ${RPM_BUILD_ROOT}%{_prefix}/lib/locale/$i/LC_NUMERIC
	touch ${RPM_BUILD_ROOT}%{_prefix}/lib/locale/$i/LC_PAPER
	touch ${RPM_BUILD_ROOT}%{_prefix}/lib/locale/$i/LC_TELEPHONE
	touch ${RPM_BUILD_ROOT}%{_prefix}/lib/locale/$i/LC_TIME
	touch ${RPM_BUILD_ROOT}%{_prefix}/lib/locale/$i/LC_MESSAGES/SYS_LC_MESSAGES
done

# Make ld.so.conf
touch $RPM_BUILD_ROOT%{_sysconfdir}/ld.so.conf
chmod 644 $RPM_BUILD_ROOT%{_sysconfdir}/ld.so.conf

# We dont have the info system in TSL-2.0
rm -rf $RPM_BUILD_ROOT%{_datadir}/info
rm -rf $RPM_BUILD_ROOT%{_prefix}/info

# /etc/localtime - Setting default localtime to GMT
rm -f $RPM_BUILD_ROOT%{_sysconfdir}/localtime
cp -f $RPM_BUILD_ROOT%{_datadir}/zoneinfo/GMT \
	$RPM_BUILD_ROOT%{_sysconfdir}/localtime



rm -rf $RPM_BUILD_ROOT%{_prefix}/share/zoneinfo
gcc -Os -static -o tzdata-update tzdata-update.c 
install -m 700 tzdata-update $RPM_BUILD_ROOT/usr/sbin/tzdata-update

# the last bit: more documentation
rm -rf documentation
mkdir documentation
cp linuxthreads/ChangeLog  documentation/ChangeLog.threads
cp linuxthreads/Changes documentation/Changes.threads
cp linuxthreads/README documentation/README.threads
cp linuxthreads/FAQ.html documentation/FAQ-threads.html
cp -r linuxthreads/Examples documentation/examples.threads
cp ChangeLog* documentation
gzip -9 documentation/ChangeLog*
exit 0

%post -p /sbin/ldconfig
%postun -p /sbin/ldconfig
%ifarch %{dualarch}
%post 32bit -p /sbin/ldconfig
%postun 32bit -p /sbin/ldconfig
%endif

%triggerin -p /usr/sbin/tzdata-update -- tzdata

%pre devel
# this used to be a link and it is causing nightmares now
if [ -L /usr/include/scsi ] ; then
    rm -f /usr/include/scsi
fi
%ifarch %{dualarch}
%pre 32bit-devel
# this used to be a link and it is causing nightmares now
if [ -L /usr/include/scsi ] ; then
    rm -f /usr/include/scsi
fi
%endif

%pre nscd
# Check whether we need to add syslog user/group
if [ -z "`getent group nscd`" ] ; then
        /usr/sbin/groupadd -g 35 nscd
fi
if [ -z "`getent passwd nscd`" ] ; then
/usr/sbin/useradd -u 35 -g 35 -c "nscd" -s /bin/false nscd 2>/dev/null
fi
# Minor clean-ups of previous bugfix 
if [ ! -s "/var/run/nscd/nscd.pid" ]; then
          killall nscd > /dev/null 2>&1
          rm -rf  /var/run/nscd/*  > /dev/null 2>&1
fi

%post nscd
/sbin/chkconfig --add nscd
if [ "$1" = "2" ]; then
/sbin/restart_maybe nscd
fi

%preun nscd
if [ "$1" = "0" ] ; then
    service nscd stop > /dev/null 2>&1
   /sbin/chkconfig --del nscd
fi

%post locales
. /usr/sbin/locales-gen

echo ''
echo 'Please edit the file /etc/locales.conf to manipulate which locales'
echo 'will be generated. Then issue the command "/usr/sbin/locales-gen"'
echo ''

%clean
[ -n "$RPM_BUILD_ROOT" -a "$RPM_BUILD_ROOT" != / ] && rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
%doc README NEWS INSTALL FAQ BUGS NOTES PROJECTS hesiod/README.hesiod
%doc documentation/* 
%config(noreplace) %{_sysconfdir}/ld.so.cache
%config(noreplace) %{_sysconfdir}/ld.so.conf
%config(noreplace) %{_sysconfdir}/localtime
%config(noreplace) %{_sysconfdir}/nsswitch.conf
%config(noreplace) %{_sysconfdir}/rpc

/%{_lib}/*
%{_prefix}/libexec/pt_chown
%{_prefix}/libexec/getconf
/sbin/ldconfig
/sbin/sln
%{_bindir}/catchsegv
%{_bindir}/gencat
%{_bindir}/getconf
%{_bindir}/getent
%{_bindir}/iconv
%{_bindir}/ldd
%{_bindir}/lddlibc4
%{_bindir}/locale
%{_bindir}/localedef
%{_bindir}/pcprofiledump
%{_bindir}/rpcgen
%{_bindir}/sprof
%{_bindir}/tzselect
%{_bindir}/xtrace
%{_sbindir}/iconvconfig
%{_sbindir}/rpcinfo
%{_sbindir}/tzdata-update
%{_sbindir}/zdump
%{_sbindir}/zic
%{_localstatedir}/db

%files profile
%defattr(-,root,root)
%{_libdir}/*_p.a

%files devel
%defattr(-,root,root)
%{_bindir}/mtrace
%{_includedir}/*
%{_libdir}/*.o
%{_libdir}/*.so
%{_libdir}/libBrokenLocale.a
%{_libdir}/libanl.a
%{_libdir}/libbsd-compat.a
%{_libdir}/libbsd.a
%{_libdir}/libc.a
%{_libdir}/libc_nonshared.a
%{_libdir}/libcrypt.a
%{_libdir}/libdl.a
%{_libdir}/libg.a
%{_libdir}/libieee.a
%{_libdir}/libm.a
%{_libdir}/libmcheck.a
%{_libdir}/libnsl.a
%{_libdir}/libpthread.a
%{_libdir}/libpthread_nonshared.a
%{_libdir}/libresolv.a
%{_libdir}/librpcsvc.a
%{_libdir}/librt.a
%{_libdir}/libutil.a
%{_mandir}/man3/*
%ifarch %{nptlarches}
%{_libdir}/nptl
%endif


%files locales
%defattr(-,root,root)
%config(noreplace) %{_sysconfdir}/locales.conf
%{_libdir}/gconv
%{_prefix}/lib/locale
%{_sbindir}/locales-gen
%{_datadir}/i18n
%{_datadir}/locale

%files nscd
%defattr(-,root,root)
%config(noreplace) %{_sysconfdir}/nscd.conf
%{_sysconfdir}/init.d/nscd
%{_sbindir}/nscd*
%ghost %config(missingok,noreplace) /var/run/nscd/nscd.pid
%ghost %config(missingok,noreplace) /var/run/nscd/socket

%ifarch %{dualarch}
%files 32bit
%defattr(-,root,root)
/lib/*

%files 32bit-profile
%defattr(-,root,root)
%{_prefix}/lib/*_p.a

%files 32bit-devel
%defattr(-,root,root)
%{_prefix}/lib/*.o
%{_prefix}/lib/*.so
%{_prefix}/lib/libBrokenLocale.a
%{_prefix}/lib/libanl.a
%{_prefix}/lib/libbsd-compat.a
%{_prefix}/lib/libbsd.a
%{_prefix}/lib/libc.a
%{_prefix}/lib/libc_nonshared.a
%{_prefix}/lib/libcrypt.a
%{_prefix}/lib/libdl.a
%{_prefix}/lib/libg.a
%{_prefix}/lib/libieee.a
%{_prefix}/lib/libm.a
%{_prefix}/lib/libmcheck.a
%{_prefix}/lib/libnsl.a
%{_prefix}/lib/libpthread.a
%{_prefix}/lib/libpthread_nonshared.a
%{_prefix}/lib/libresolv.a
%{_prefix}/lib/librpcsvc.a
%{_prefix}/lib/librt.a
%{_prefix}/lib/libutil.a
%endif


%changelog
* Tue Feb 06 2007 Nived Gopalan <nived at trustix dot org> 2.3.5-10tr
- Moved zoneinfo to tzdata package, Bug #2044.

* Mon Jul 11 2005 Bipin S <bipin at comodo dot com> 2.3.5-9tr
- Minor clean up of previously fixed bug for proper working of nscd.
  Fixed bug#1086

* Mon Jul 11 2005 Bipin S <bipin at comodo dot com> 2.3.5-8tr
- created /var/run/nscd and /var/db/nscd. Fixed bug#1053

* Fri Jun 17 2005 Oystein Viggen <oysteivi at trustix dot com> 2.3.5-7tr
- glibc-2.3.5-path_vi.patch: vi is /bin/vi, not /usr/bin/vi

* Wed Jun 15 2005 Syed Shabir Zakiullah <syedshabir at comodo dot com> 2.3.5-6tr
- Re-formatted /etc/locales.conf, Fixed Bug #839.

* Mon Apr 25 2005 Syed Shabir Zakiullah <syedshabir at comodo dot com> 2.3.5-3tr
- Applied gcc4 patch, Rebuilt against gcc-4.0

* Wed Apr 20 2005 Hasher Jamaludeen <hasher at comodo dot com> 2.3.5-2tr
- Changed init priority

* Mon Apr 11 2005 Syed Shabir Zakiullah <syedshabir at comodo dot com> 2.3.5-1tr
- New Upstream

* Sun Mar 13 2005 Erlend Midttun <erlendbm at trustix dot org> 2.3.4-6tr
- Just toss the NPTL files in under the devel package.

* Fri Mar 11 2005 Erlend Midttun <erlendbm at trustix dot org> 2.3.4-5tr
- Ship the released 2.3.4

* Wed Feb 16 2005 Syed Shabir <syedshabir at comodo dot com> 2.3.4-4tr
- Glibc with NPTL+LinuxThreads
- Added tls.h patch to fix tls.h compilation error for LinuxThreads

* Mon Oct 25 2004 Chr. Toldnes <christht at trustix dot org> 2.3.3-13tr
- new glibc date: 200408300000

* Fri Oct 22 2004 Oystein Viggen <oysteivi at trustix dot com> 2.3.3-12tr
- Revert to CVS version 20040902134

* Thu Oct 14 2004 Erlend Midttun <erlendbm at trustix dot org> 2.3.3-11tr
- New CVS export.

* Fri Oct  4 2004 Chr. Toldnes <christht at trustix dot org> 2.3.3-10tr
- Fixed messed up filelist

* Fri Oct  1 2004 Chr. Toldnes <christht at trustix dot org> 2.3.3-9tr
- move /usr/bin/mtrace to devel because of perl dependency

* Tue May 18 2004 Chr. Toldnes <christht at trustix dot org> 2.3.3-5tr
- Extensive renaming of packages:
  + all now begin with 'glibc-' including nscd
  + 32 bit packages begin with 'glibc-32bit-'

* Fri May 14 2004 Oystein Viggen <oysteivi at trustix dot com> 2.3.3-4tr
- Forward umount calls to umount2 for native ppc64 builds

* Wed Apr 21 2004 Chr. Toldnes <christht at trustix dot org> 2.3.3-3tr
- readded header files... ;P

* Wed Apr 21 2004 Chr. Toldnes <christht at trustix dot org> 2.3.3-2tr
- Fixed buggy libbsd.a
- General cleanup

* Mon Apr 19 2004 Chr. Toldnes <christht at trustix dot org> 2.3.3-1tr
- New upstream version taken from redhat to match ppc64 needs.
  (prep and build parts ripped as well)
- %_libdir and %_lib usage
- Support for both 32 and 64 bit if x86_64 or ppc64

* Wed Jan 14 2004 Chr. Toldnes <christht at trustix dot org> 2.3.2-13tr
- Ensure empty $LD_LIBRARY_PATH

* Thu Nov 25 2003 Erlend Midttun <erlendbm at trustix dot org> 2.3.2-12tr
- Big rebuild

* Fri Nov 14 2003 Chr. Toldnes <christht at trustix dot org> 2.3.2-11tr
- Fixed getgrouplist issues

* Fri Oct 31 2003 Chr. Toldnes <christht at trustix dot org> 2.3.2-10tr
- backport

* Sun Sep 28 2003 Chr. Toldnes <christht at tawie dot org> 2.3.2-9tsl
- port to tawie

* Mon Jun 30 2003 Erlend Midttun <erlendbm at trustix dot com> 2.3.2-8tr
- Rebuild with -tr suffix.
- Removed userdel as well.

* Sun Jun 29 2003 Jan�e R�nblom <janron at trustix dot org> 2.3.2-8jr
- fixed nscd script
- removed groupdel from uninstall of nscd since userdel removes the group

* Wed Jun 18 2003 Erlend Midttun <erlendbm at trustix dot com> 2.3.2-7tr
- Big rebuild

* Fri May 23 2003 Erlend Midttun <erlendbm at trustix dot com> 2.3.2-6em
- Try to clean up filelist.

* Fri May 16 2003 Erlend Midttun <erlendbm at trustix dot com> 2.3.2-5em
- Added sscanf patch to compile against GCC 3.3

* Thu May 16 2003 Erlend Midttun <erlendbm at trustix dot com> 2.3.2-4em
- _PATH_VI -> /bin/vim
- chmod 644 ld.so.conf

* Tue Apr 22 2003 Erlend Midttun <erlendbm at trustix dot com> 2.3.2-3em
- Fixed uid/gid

* Mon Mar 24 2003 Erlend Midttun <erlendbm at trustix dot com> 2.3.2-2em
- Rebuilt against glibc 2.3.2.

* Mon Mar 24 2003 Erlend Midttun <erlendbm at trustix dot com> 2.3.2-1em
- New upstream.

* Thu Mar 20 2003 Erlend Midttun <erlendbm at trustix dot com> 2.2.5-19em
- Added XDR patches agains CA-2003-10.

* Fri Feb 28 2003 Erlend Midttun <erlendbm at trustix dot com> 2.2.5-18em
- Add nscd user with correct uid.

* Tue Feb 25 2003 Erlend Midttun <erlendbm at trustix dot com> 2.2.5-17em
- Trying again to add nscd user.
- Fix locales as reported by gda.

* Mon Jan 27 2003 Erlend Midttun <erlendbm at trustix dot com> 2.2.5-16em
- Incorrect group in glibc-locales.

* Thu Jan 23 2003 Erlend Midttun <erlendbm at trustix dot com> 2.2.5-15em
- Fixed initscript (#62).
- Added quotes to the getent lines.

* Thu Jan 16 2003 Erlend Midttun <erlendbm at trustix dot com> 2.2.5-14em
- Change kernel-headers into linux-headers.

* Wed Dec  3 2002 Christian H. Toldnes <christht at trustix dot com> 2.2.5-13ct
- The nscd initscript follows the policy.
- Separate source for the init script.

* Thu Oct 14 2002 Christian H. Toldnes <christht at trustix dot com> 2.2.5-12ct
- Patched for several security issues. (Patch 9-11)

* Thu Oct  3 2002 Gerald Dachs <gda at trustix dot org> 2.2.5-11gd
- made /etc/ld.so.conf empty

* Tue Aug 27 2002 Erlend Midttun <erlendbm at trustix dot com> 2.2.5-10em
- Made changes to build with GCC 3.2.

* Thu Jul 25 2002 Gerald Dachs <gda at trustix dot org> 2.2.5-9gd
- Patch2 applied, because of buffer overflow in multiple DNS resolver
  libraries. CERT Advisory CA-2002-19.

* Thu Jul 18 2002 Christian H. Toldnes <christht at trustix dot com> 2.2.5-8ct
- Moved from /etc/rc.d/init.d to /etc/init.d
- Added check before making nscd user and group
- en_US not default locale, using default 'C' instead, because of problems with
  sorting in glibc-2.2.x locales
- All locales stuff now back in -locales sub package.
- Must define 'C' in /etc/profile, but not in this package. /etc/profile belongs
  to the 'setup' package.

* Tue Jun 25 2002 Roland Kruse <rolandk at trustix dot com> 2.2.5-7rk
- Added glibc_post_upgrade program for %post section to avoid
  dependency of bash package (caused circular dependency)

* Wed Jun 12 2002 Christian H. Toldnes <christht at trustix dot com> 2.2.5-6ct
- Force creation of system locales even if warnings have been issued.
- Even more filelist-cleanups.

* Tue Jun 11 2002 Christian H. Toldnes <christht at trustix dot com> 2.2.5-5ct
- Correct chkconfig-handling of nscd.
- moved /etc/init.d/nscd to /etc/rc.d/init.d/
- This is for a new distro, removed 'Obsoletes:'
- more filelist cleanups.

* Mon Jun 10 2002 Christian H. Toldnes <christht at trustix dot com> 2.2.5-4ct
- more filelist cleanups.
- Moved manpages to confirm with FSH
- Removed all the info-stuff.

* Fri Jun  7 2002 Christian H. Toldnes <christht at trustix dot com> 2.2.5-3ct
- Fixed /etc/locales.conf
- Made the .so.X-links actually be a part of the package.

* Thu May 30 2002 Christian H. Toldnes <christht at trustix dot com>
- Rebuild with -2ct releasetag.
- Todo: Fix /etc/locales.conf

* Mon Feb 18 2002 Christian H. Toldnes <christht at trustix dot com>
- Added /etc/locales.conf, and new locales-gen

* Wed Feb 13 2002 Erlend Midttun <erlendbm at trustix dot com>
- Strip .so's
- Added nsswitch.conf :)
- Added nsswitch.conf and ld.so.conf to file list.
- Added files for nscd again :)

* Mon Jan 21 2002 Christian H. Toldnes <christht at trustix dot com>
- New upstream version: 2.2.5
- Now let src-maintainer deside which locales are supported.
- Patched the ugly cpp-script to actually build the lot.
- Moved the locales generated into /usr/lib/locales (localedef).
- Only en_US generated by default in %post, rest by user.

* Wed Dec 10 2001 Christian H. Toldnes <christht at trustix dot com>
- Complete remake to fit glibc 2.2
- Data files for NLS into separate package (-locales).
- Most locales generated in post-installation script.
- Current version is: 2.2.4
